/*     This file is part of mux-sw.

    mux-sw is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    mux-sw is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with mux-sw.  If not, see <http://www.gnu.org/licenses/>.
*/
 
#ifndef __RF_MUX_H__
#define __RF_MUX_H__

#include "mcp23s17.h"

namespace RF_MUX {

class RF_MUX {
  public:
  //RF_MUX() {
  //}
  RF_MUX(char id, int8_t SDIO, int8_t CSB, int8_t SCLK) {
    _io = new MCP23S17::MCP23S17(SDIO, CSB, SCLK);
    _id = id;
  }
  ~RF_MUX() {
    delete _io;
  }
  void init(){
    _io->set_pin_mode(MCP23S17::PINMODE_OUTPUT);
    set(0); // reset to state zero
  }
  void set(uint8_t ch) {
    // don't accept invalid states
    if (ch<0) {
      return;
    } else if (ch>8) {
      return;
    } else if (ch==_state) {
      return; // nothing to do.
    }
      
    _state = ch;
    _io->set_gpio( MCP23S17::PINA[_state], MCP23S17::PINB[_state] );
  }
  uint8_t get() {
    return _state;
  }
  const char get_id() {
    return _id;
  }
  private:
      MCP23S17::MCP23S17* _io;
      uint8_t _state;
      char _id;

}; // end class

} // end namespace

#endif 
